//------ nécessaire pour gérer le port série ----------
import processing.serial.*;
Serial port=null;
//----------------------------------------------------
//////////////////////////////////////////// setup() /////////////////////////////////////////////////////////////////////////
void setup() {
    size(1366, 768, P2D);
    colorMode(RGB, 255, 255, 255);
    imageMode(CORNER);
    noStroke();
    Repertoire_Decoduino = sketchPath("");
                                                                                                                              println(Repertoire_Decoduino);
    Courier12 = createFont(Repertoire_Decoduino+"data/SLC_.ttf", 12, true);
    Courier14 = createFont(Repertoire_Decoduino+"data/SLC_.ttf", 14, true);
    Courier17 = createFont(Repertoire_Decoduino+"data/SLC_.ttf", 17, true);
    fontUnits = createFont(Repertoire_Decoduino+"data/DSEG7Classic-BoldItalic.ttf", TAILLE_POLICE, true);
    textFont(Courier12);
    textFont(Courier14);
    textFont(Courier17);
    int Repertoire_Decoduino_length = Repertoire_Decoduino.length();
    Repertoire_Communs = Repertoire_Decoduino.substring(0, Repertoire_Decoduino_length-26)+"Communs/";
                                                                                                                              println(Repertoire_Communs);
    fond_alu1 = loadImage("data/Fond alu1.png");
    fond_alu  = loadImage("data/Fond alu.png");
    gestion   = new Gestion();
    imageMode(CORNER);                                                                                                        //  on affiche le plus tôt possible dans le setup() pour diminuer l'écran blanc du départ
    image(fond_alu, 0, 0, width, height);
    String texte = "Chargement des fichiers";
    gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
    textFont(Courier17);
    textAlign(CENTER, CENTER);
    text(texte, width/2F, height/2F);
    zone      = new Zone();
    bouton    = new Bouton();
    trouve = false;
    texte_ecrire = "";
}
/////////////////////////////////// draw() ///////////////////////////////////////////////////////////
void draw() {
    if (charge_tables) {
        image(fond_alu, 0, 0, width, height);                                                                                 //  on doit réafficher en entrant dans le draw() pour eviter un écran noi
        String texte = "Chargement des fichiers";
        gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
        text(texte, width/2F, height/2F);
        gestion.liste_decodeurs();
        gestion.liste_fabricants();
        gestion.liste_familles();
        gestion.liste_modeles();
        charge_images();
        creation_table_Materiel();
        charge_table_Materiel();
        creation_table_Proprietaires();
        charge_table_Proprietaires();
        if (tables_construites) {
            charge_tables = false;
        }
    } else {
        if (cherche_arduino) {
            gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier17);
            textAlign(CENTER, CENTER);
            text("Recherche de l'Arduino", width/2F, height/2F);
            if (texte_ecrire.equals("")) {
                connexion();
            }
            fin_comptage = millis();
            if (fin_comptage-debut_comptage < 3000 || !trouve) {
                gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
                textFont(Courier17);
                textAlign(CENTER, CENTER);
                text(texte_ecrire, width/2F, height/2F);
            } else {
                cherche_arduino = false;
            }
        } else {
            if (cherche_fichier) {
                String texte = "Vérification du fichier Materiel.tsv";
                gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
                text(texte, width/2F, height/2F);
                choix_du_vehicule = true;
                //------------------ affichage du message d'erreur sur Materiel.tsv ---------
                try { 
                    saveTable(Materiel, Repertoire_Communs+"Materiel/Materiel.tsv");
                } catch (Exception IOException) {
                    maj_decodeur = false;
                    texte = "Le fichier Matériel.tsv est ouvert"
                             +char(10)+"dans une autre application"
                    +char(10)+char(10)+"Fermez Materiel.tsv"
                             +char(10)+"et relancez le programme";
                    gestion.dessine_rectangle_inverse((1366F-500)/2F, (768F-300F)/2F, 500F, 300F);
                    text(texte, width/2F, height/2F);
                    choix_du_vehicule = false;
                }
                cherche_fichier = false;
                vehicule = tous_vehicules_complet.get(0);
                initialise_CV_decodeur();
            } else {
                if (mousePressed) {
                    top++;
                } else {
                    top = 0;
                }
                //---------------------- choix du véhicule ---------------
                if (choix_du_vehicule) {
                    imageMode(CORNER);
                    image(fond_alu, 0, 0, width, height);
                    gestion.choix_vehicule();
                    groupe = groupes[0];
                    groupe.choix_bouton_actions_vehicule();
                    gestion.dessine_curseurH(0);
                }
                //---------------------- Bouton ajouter un décodeur -----------------
                if (ajouter_decodeur) {
                    groupe = groupes[2];
                    groupe.choix_bouton_decodeur();
                    if (gestion.one_shot) {
                        imageMode(CORNER);
                        image(fond_alu, 0, 0, width, height);
                        gestion.dessine_fabricants();
                        gestion.dessine_familles();
                        gestion.dessine_modeles();
                    }
                    gestion.dessine_decodeur();            
                    for (Decodeur dec0 : tous_decodeurs) {
                        decodeur = dec0;
                        if (dec0 != null && dec0.onglet_choisi != null) {
                            for (Onglet ong0 : tous_onglets) {
                                if (ong0.nom_onglet.equals(dec0.onglet_choisi)) {
                                    ong0.dessine_onglet();
                                    onglet = ong0;
                                    if (onglet.Groupes[0] != null) {
                                        int nb_zones = onglet.Groupes[0].Boutons.length;
                                        for (int i = 0; i < nb_zones; i++) {
                                            //--------------------- choisir_texte ------------------------
                                            if (groupe.Boutons[i].choix[i]) {
                                                groupe.Boutons[i].liste_choix(i);
                                            }
                                        }
                                    }
                                    int nb_groupes = onglet.Groupes.length;
                                    if (nb_groupes > 1) {
                                        if (onglet.Groupes[1] != null) {
                                            int nb_zones = onglet.Groupes[1].Boutons.length;
                                            for (int i = 0; i < nb_zones; i++) {
                                                 groupe1.valide_onglet();
                                            }
                                        }
                                    }
                                }
                            }  
                        }
                    }
                }
                //---------------------- Bouton MàJ décodeur -----------------
                if (maj_decodeur) {
                    groupe = groupes[2];
                    groupe.choix_bouton_decodeur();
                    gestion.dessine_decodeur();
                    for (Decodeur dec0 : tous_decodeurs) {
                        decodeur = dec0;
                        if (dec0.onglet_choisi != null) {
                            for (Onglet ong0 : tous_onglets) {
                                if (ong0.nom_onglet.equals(dec0.onglet_choisi)) {
                                    ong0.dessine_onglet();
                                    onglet = ong0;
                                    if (onglet.Groupes[0] != null) {
                                        groupe = onglet.Groupes[0];
                                        int nb_zones = min(NB_CHOIX, groupe.Boutons.length);
                                        for (int i = 0; i < nb_zones; i++) {
                                            bouton = groupe.Boutons[i];
                                            //--------------------- choisir_texte ------------------------
                                            if (groupe.Boutons[i].choix[i]) {
                                                groupe.Boutons[i].liste_choix(i);
                                            }
                                        }
                                    }
                                    int nb_groupes = onglet.Groupes.length;
                                    if (nb_groupes > 1) {
                                        if (onglet.Groupes[1] != null) {
                                            int nb_zones = onglet.Groupes[1].Boutons.length;
                                            for (int i = 0; i < nb_zones; i++) {
                                                 groupe1.valide_onglet();
                                            }
                                        }
                                    }
                                }
                            }  
                        }
                    }
                }
                //--------------------- Coller les CV ------------------------
                if (coller_CV) {
                    groupe = groupes[1];
                    groupe.choix_bouton_copie();
                }
                //---------------------------- gestion des filtres ----------------------------
                for (int i = 0; i < 5; i++) {
                    //--------------------- choisir_filtre ------------------------
                    groupe = groupes[0];
                    if (groupe.Boutons[i+8].choix[i]) {
                        groupe.Boutons[i+8].choisir_filtre(i);
                    }
                    //--------------------- afficher_filtre ------------------------
                    if (groupe.Boutons[i+8].texte_choisi != null && !groupe.Boutons[i+8].choix[i]) {
                        imageMode(CENTER);
                        textFont(Courier14);
                        textAlign(CENTER);
                        fill(NOIR);
                        if (i%2 == 0) {
                            //-------------- affichage au dessus du bouton ------------
                            image(affiche_vert, groupe.Boutons[i+8].x+textWidth(groupe.Boutons[i+8].texte_affiche)/2F, groupe.Boutons[i+8].y-15F, textWidth(groupe.Boutons[i+8].texte_choisi)*1.2F, 15F);
                            text(groupe.Boutons[i+8].texte_choisi, groupe.Boutons[i+8].x+(textWidth(groupe.Boutons[i+8].texte_affiche))/2F, groupe.Boutons[i+8].y-11F);
                        } else {
                            //-------------- affichage en dessous du bouton ------------
                            image(affiche_vert, groupe.Boutons[i+8].x+textWidth(groupe.Boutons[i+8].texte_affiche)/2F, groupe.Boutons[i+8].y+55F, textWidth(groupe.Boutons[i+8].texte_choisi)*1.2F, 15F);
                            text(groupe.Boutons[i+8].texte_choisi, groupe.Boutons[i+8].x+textWidth(groupe.Boutons[i+8].texte_affiche)/2F, groupe.Boutons[i+8].y+59F);
                        }
                    }
                }
                //--------------------- Boutons_confirmation -------------------------
                if (confirmation) {
                    groupe = groupes[3];
                    groupe.confirmation();
                }
                //--------------------- Sauver et sortir ---------------------
                if (sauver_et_sortir) {
                    sauve_table_Materiel();
                    sauver_et_sortir  = false;
                    choix_du_vehicule = true;
                }
                //-------------------- lire_CV -----------------------------
                if (appui_CV != 0 && !transfert_fich_dec && !transfert_dec_fich) {
                    lire_CV();
                }
            }
        }
    }
}
