//*************************************** Gestion() ********************************************
class Gestion {
    Decodeur decodeurs[] = new Decodeur[NB_DECODEURS];
    Decodeur decodeur_choisi;
    float   largeur_fabricant = 0F;
    String  fabricant_choisi  = ".";
    int     ligne_fabricant   = -1;
    float   largeur_famille   = 0F;
    String  famille_choisie   = ".";
    int     ligne_famille     = -1;
    float   largeur_modele    = 0F;
    String  modele_choisi     = ".";
    int     ligne_modele      = -1;
    boolean one_shot          = false;
    float   x0                = 120F;
    float   y0                = 320F;
    float   l0                = width-240F;
    float   curseur_left      = x0;
    float   curseur_right     = x0+l0;
    int     numero_curseur    = 0;
    float   largeur_curseur[] = new float[1];
    String  texte_echelle;

    Gestion() {
       decodeurs[0]    = new Modele_generique();
       decodeurs[1]    = new LE030();
       decodeurs[2]    = new LE040();
       decodeurs[3]    = new LE130();
       decodeurs[4]    = new LE135();
       decodeurs[5]    = new LE230();       
       decodeurs[6]    = new LE010XF();       
       decodeurs[7]    = new LE011XF();       
       decodeurs[8]    = new LE130XF();       
       decodeurs[9]    = new LE0521W();       
       decodeurs[10]   = new LE0521D();       
       decodeurs[11]   = new LE1024();       
       decodeurs[12]   = new LE1025C();       
       decodeurs[13]   = new LE4024();       
       decodeurs[14]   = new MX61_2000_Version_4_10();
       decodeurs[15]   = new MX61_2000_Version_11_17();
       decodeurs[16]   = new MX61_N();
       decodeurs[17]   = new MX620_Version_1_3();
       decodeurs[18]   = new MX620_Version_5();
       decodeurs[19]   = new MX620_Version_6();
       decodeurs[20]   = new MX620_Version_7_8();
       decodeurs[21]   = new MX620_Version_9();
       decodeurs[22]   = new MX620_Version_9_12();
       decodeurs[23]   = new MX617_Version_Fleischmann();
       
       groupes[0]      = new Vehicule_ligne1();
       groupes[1]      = new Copie_ligne2();
       groupes[2]      = new Decodeur_ligne1();
       groupes[3]      = new Boutons_confirmation();
       groupes[4]      = new Choix_vehicule();
    }

    //---------------------------- choix_vehicule() ----------------------
    void choix_vehicule() {
        //------------------------ case de l'image du véhicule ---------------------
        dessine_rectangle(x0-60, y0-280, l0+120, y0-80);
        imageMode(CENTER);
        image(vehicule.image_cote, width/2F, y0-160-10, vehicule.image_cote.width, vehicule.image_cote.height);
        //----------------------- curseur et petits boutons bleus --------------------
        stroke(NOIR);
        line(x0, y0, x0+l0, y0);
        //----------------------- variables du véhicule ------------------------------
        dessine_rectangle(x0-60, y0+40, 800, 100);
        dessine_rectangle(900,   y0+40, 406, 100);
        
        fill(NOIR);
        textFont(Courier14);
        textAlign(CENTER, CENTER);
        text("INFOS SUR LE VEHICULE", x0-60F+800/2F, y0+50);
        text("INFOS SUR LE DECODEUR", 900F+406F/2F,  y0+50);
        textAlign(LEFT, CENTER);
        text("Nom :",                  x0-60F+10,     y0+70F);
        text("Marque :",               x0-60F+10F,    y0+85F);
        text("Référence :",            x0-60F+10F,    y0+100F);
        text("ID(+1) :",               x0-60F+450F,   y0+70F);
        text("Moteur :",               x0-60F+450F,   y0+85F);
        text("Hors tampons (en mm) :", x0-60F+450F,   y0+100F);
        text("Fabricant :",            x0-60F+850F,   y0+70F);
        text("Famille :",              x0-60F+850F,   y0+85F);
        text("Modèle :",               x0-60F+850F,   y0+100F);
        
        fill(AQUA);
        textAlign(RIGHT, CENTER);
        text(vehicule.nom,             x0-60F+400F,   y0+70F);
        text(vehicule.marque,          x0-60F+400F,   y0+85F);
        text(vehicule.ref,             x0-60F+400F,   y0+100F);
        text(str(vehicule.ID+1)+"/"+str(tous_vehicules.size()), x0-60F+750F,   y0+70F);
        text(str(vehicule.moteur),     x0-60F+750F,   y0+85F);
        text(str(vehicule.htamp),      x0-60F+750F,   y0+100F);
        if (!vehicule.fabricant.equals("Inconnu")) {
            int fab = vehicule.famille.indexOf("/");
            int mod = vehicule.modele.indexOf("//");
            text(vehicule.fabricant,                x0-60F+1200F,  y0+70F);
            text(vehicule.famille.substring(fab+1), x0-60F+1200F,  y0+85F);
            text(vehicule.modele.substring(mod+2),  x0-60F+1200F,  y0+100F);
        } else {
            text("Inconnu",  x0-60F+1200F,  y0+70F);
            text("Inconnue", x0-60F+1200F,  y0+85F);
            text("Inconnu",  x0-60F+1200F,  y0+100F);
        }
        if (copier_CV) {
            fill(AQUA);
            textAlign(CENTER, TOP);
            text("Véhicule dont les CV sont à copier", 60F+((l0+120F)/4F)/2F, 600F);
            //---------------- vehicule ---------------        
            gestion.dessine_rectangle(60F, 650F, (l0+120F)/4F, 100F);
            imageMode(CENTER);
            image(tous_vehicules.get(vehicule_copie).image_cote, 60F+((l0+120F)/4F)/2F, 650F+100F/2F, 
                  tous_vehicules.get(vehicule_copie).image_cote.width/4F, tous_vehicules.get(vehicule_copie).image_cote.height/4F);
            imageMode(CORNER);
        }
        if (coller_CV) {
            
            fill(AQUA);
            textAlign(CENTER, TOP);
            if (vehicule.fabricant != "Inconnu") {
                text("Véhicule dans lequel on copie les CV", 60F+((l0+120F)/4F)+60F+((l0+120F)/4F)/2F, 600F);
            } else {
                imageMode(CORNER);
                image(danger, 60F+((l0+120F)/4F)+60F, 600F, 20F, 20F);
                textAlign(LEFT, TOP);
                text("On ne peut pas coller les CV dans un véhicule qui n'a pas de décodeur", 60F+300F+60F+30F, 600F);
            }
            //---------------- vehicule ---------------        
            gestion.dessine_rectangle(60F+((l0+120F)/4F)+60F, 650F, ((l0+120F)/4F), 100F);
            imageMode(CENTER);
            image(vehicule.image_cote, 60F+((l0+120F)/4F)+60F+((l0+120F)/4F)/2F, 650F+100F/2F, vehicule.image_cote.width/4F, vehicule.image_cote.height/4F);
            imageMode(CORNER);
        }
        if (!copier_CV) {
            imageMode(CORNER);
            image(composition, 0F, 568F, 1366F, 200F);
        }
        //------------------------------ boutons choix vehicule ----------------------------
        groupe = groupes[4];
        groupe.choix_vehicule(x0-60F, y0-10F, l0+100F);
    }
    //---------------------------------- dessine_curseurH() ---------------------------------------------------------
    void dessine_curseurH(int _numero_curseur) {
        if (mouseX > x0+10  && mouseX < x0+l0-10
         && mouseY > y0-20  && mouseY < y0+20) {
            if (mousePressed) {
                dans_curseurH_vehicule = true;
                numero_curseur = _numero_curseur;
            }
        }
        imageMode(CORNER);
        image(curseurH, curseur_left+largeur_curseur[_numero_curseur]-15F, y0-10F, 30F, 20F);
    }
    //--------------------------- liste_decodeurs() -----------------------
    void liste_decodeurs() {
        tous_decodeurs.clear();
        for (int i = 0; i < NB_DECODEURS; i++) {
            if (decodeurs[i] != null) {
                tous_decodeurs.add(decodeurs[i]);
            }
        }
    }   
    //--------------------------- liste_fabricants() -----------------------
    void liste_fabricants() {
        tous_fabricants.clear();
        for (Decodeur dec0 : tous_decodeurs) {
            if (dec0 != null) {                
                boolean trouve = false;
                for (String fab0 : tous_fabricants) {
                    if (fab0.equals(dec0.nom_fabricant)) {
                        trouve = true;
                        break;
                    }
                }
                if (!trouve) {
                    tous_fabricants.append(dec0.nom_fabricant);
                    if (largeur_fabricant < (dec0.nom_fabricant.length()+2)*ZOOM) {
                        largeur_fabricant = (dec0.nom_fabricant.length()+2)*ZOOM;
                    }
                }
            }
        }
        tous_fabricants.sort();
    }   
    //--------------------------- liste_familles() -----------------------
    void liste_familles() {
        toutes_familles.clear();
        for (Decodeur dec0 : tous_decodeurs) {
            if (dec0 != null) {
                boolean trouve = false;
                for (String fam0 : toutes_familles) {
                    if (fam0.equals(dec0.nom_famille)) {
                        trouve = true;
                        break;
                    }
                }
                if (!trouve) {
                    toutes_familles.append(dec0.nom_famille);
                    int fab = dec0.nom_famille.indexOf("/");
                    if (largeur_famille < (dec0.nom_famille.substring(fab+1, dec0.nom_famille.length()).length()+2)*ZOOM) {
                        largeur_famille = (dec0.nom_famille.substring(fab+1, dec0.nom_famille.length()).length()+2)*ZOOM;
                    }
                }
            }
        }
        toutes_familles.sort();
    }   
    //--------------------------- liste_modeles() -----------------------
    void liste_modeles() {
        tous_modeles.clear();
        for (Decodeur dec0 : tous_decodeurs) {
            if (dec0 != null) {
                boolean trouve = false;
                for (String mod0 : tous_modeles) {
                    if (mod0.equals(dec0.nom_modele)) {
                        trouve = true;
                        break;
                    }
                }
                if (!trouve) {
                    tous_modeles.append(dec0.nom_modele);
                    int mod = dec0.nom_modele.indexOf("//");
                    if (largeur_modele < (dec0.nom_modele.substring(mod+2, dec0.nom_modele.length()).length()+2)*ZOOM) {
                        largeur_modele = (dec0.nom_modele.substring(mod+2, dec0.nom_modele.length()).length()+2)*ZOOM;
                    }
                }
            }
        }
        tous_modeles.sort();
    }  
    //-------------------- dessine_fabricants() ------------------------------
    void dessine_fabricants() {
        affiche_en_tete = false;
        textFont(Courier14);
        dessine_les_fabricants = true;
        dessine_rectangle(10, 10, largeur_fabricant, 4+tous_fabricants.size()*15);
        //----------------------- gros boutons bleus2 ---------------------------------
        groupe = groupes[2];
        groupe.dessine_gros_boutons(1000F, 5F, width-1000F-60F, 40F);
        groupe.appui_gros_boutons();
        //-----------------------------
        int compte_fabricants = -1;
        textFont(Courier14);
        textAlign(LEFT);
        for (String fab0 : tous_fabricants) {
            compte_fabricants++;
            for (Decodeur dec0 : tous_decodeurs) {
                dec0.onglet_choisi = null;
                if (dec0.nom_fabricant.equals(fab0)) {
                    if (mouseX > 10                      && mouseX < 10+largeur_fabricant
                     && mouseY > 10+15*compte_fabricants && mouseY < 24+15*compte_fabricants) {
                        fill(NOIR);
                        imageMode(CORNER);
                        image(affiche_bleu, 13, 12+15*compte_fabricants, (fab0.length()+1)*ZOOM, 15);
                    } else {
                        fill(BLANC);
                    }
                }
            }                        
            strokeWeight(1);
            text(fab0, 15, 24+15*compte_fabricants);
        }
        if (ligne_fabricant != -1) {
            imageMode(CORNER);
            image(affiche_vert, 13, 12+15*ligne_fabricant, (fabricant_choisi.length()+1)*ZOOM, 15);            
            strokeWeight(1);
            fill(NOIR);
            text(fabricant_choisi, 15, 24+15*ligne_fabricant);
        }
    }
    //-------------------- dessine_familles() ------------------------------
    void dessine_familles() {
        textFont(Courier14);
        if (ligne_fabricant != -1) {
            dessine_les_familles   = true;
            int compte_familles = 0;
            for (String fam0 : toutes_familles) {
                int fab = fam0.indexOf("/");
                if (fam0.substring(0, fab).equals(fabricant_choisi)) {
                    compte_familles++;
                }
            }
            dessine_rectangle(20+largeur_fabricant, 10, largeur_famille, 4+compte_familles*15);
            compte_familles = -1;
            for (String fam0 : toutes_familles) {
                int fab = fam0.indexOf("/");
                if (fam0.substring(0, fab).equals(fabricant_choisi)) {
                    compte_familles++;
                    for (Decodeur dec0 : tous_decodeurs) {
                        if (dec0 != null && dec0.nom_famille.equals(fam0)) {
                            if (mouseX > 20+largeur_fabricant  && mouseX < 20+largeur_fabricant+largeur_famille
                             && mouseY > 10+15*compte_familles && mouseY < 24+15*compte_familles) {
                                fill(NOIR);
                                imageMode(CORNER);
                                image(affiche_bleu, 23+largeur_fabricant, 12+15*compte_familles, (fam0.substring(fab+1, fam0.length()).length()+1)*ZOOM, 15);
                            } else {
                                fill(BLANC);
                            }
                        }
                    }                        
                    strokeWeight(1);
                    text(fam0.substring(fab+1, fam0.length()), 25+largeur_fabricant, 24+15*compte_familles);
                }
            }
            if (ligne_famille != -1) {
                int fab = famille_choisie.indexOf("/");
                imageMode(CORNER);
                image(affiche_vert, 23+largeur_fabricant, 12+15*ligne_famille, (famille_choisie.substring(fab+1, famille_choisie.length()).length()+1)*ZOOM, 15);
                strokeWeight(1);
                fill(NOIR);
                text(famille_choisie.substring(fab+1, famille_choisie.length()), 25+largeur_fabricant, 24+15*ligne_famille);
            }
        }
    }
    //-------------------- dessine_modeles() ------------------------------
    void dessine_modeles() {
        textFont(Courier14);
        if (ligne_famille != -1) {
            dessine_les_modeles = true;
            int compte_modeles = 0;
            for (String mod0 : tous_modeles) {
                int mod = mod0.indexOf("//");
                if (mod0.substring(0, mod).equals(famille_choisie)) {
                    compte_modeles++;
                }
            }
            dessine_rectangle(30+largeur_fabricant+largeur_famille, 10, largeur_modele, 4+compte_modeles*15);
            compte_modeles = -1;
            for (String mod0 : tous_modeles) {
                int mod = mod0.indexOf("//");
                if (mod0.substring(0, mod).equals(famille_choisie)) {
                    compte_modeles++;
                    for (Decodeur dec0 : tous_decodeurs) {
                        if (dec0 != null && dec0.nom_modele.equals(mod0)) {
                            if (mouseX > 30+largeur_fabricant+largeur_famille && mouseX < 30+largeur_fabricant+largeur_famille+largeur_modele
                             && mouseY > 10+15*compte_modeles                 && mouseY < 24+15*compte_modeles) {
                                fill(NOIR);
                                imageMode(CORNER);
                                image(affiche_bleu, 33+largeur_fabricant+largeur_famille, 12+15*compte_modeles, (mod0.substring(mod+2, mod0.length()).length()+2)*ZOOM, 15);
                                break;
                            } else {
                                fill(BLANC);
                            }
                        }
                    }                        
                    strokeWeight(1);
                    text(mod0.substring(mod+2, mod0.length()), 35+largeur_fabricant+largeur_famille, 24+15*compte_modeles);
                }
            }
            if (ligne_modele != -1) {
                int mod = modele_choisi.indexOf("//");
                imageMode(CORNER);
                image(affiche_vert, 33+largeur_fabricant+largeur_famille, 12+15*ligne_modele, (modele_choisi.substring(mod+2, modele_choisi.length()).length()+2)*ZOOM, 15);            
                strokeWeight(1);
                fill(NOIR);
                text(modele_choisi.substring(mod+2, modele_choisi.length()), 37+largeur_fabricant+largeur_famille, 24+15*ligne_modele);
                for (String mod0 : tous_modeles) {
                    mod = mod0.indexOf("//");
                    if (mod0.substring(0, mod).equals(famille_choisie)) {
                        tous_onglets.clear();
                        int   nb_onglets     = decodeur_choisi.Onglets.length;
                        for (int i = 0; i < nb_onglets ; i++) {
                            tous_onglets.add(decodeur_choisi.Onglets[i]);
                        }
                    }
                }
            }            
        }
    }
    //-------------------- dessine_decodeur() ------------------------------
    void dessine_decodeur() {
        if (ligne_modele != -1) {
            //----------------------------- récupération : fabricant, modèle, référence --------------
            if (one_shot) {
                dessine_en_tete();
                for (Decodeur dec0 : tous_decodeurs) {
                    if (dec0 != null && dec0.nom_modele.equals(modele_choisi)) {
                        dec0.calcule_donnees();
                        for (Zone zon0 : dec0.toutes_zones) {
                            if (zon0.nom_zone.equals("Fiche")) {
                                one_shot = false;
                                dec0.onglet_choisi = zon0.nom_zone;
                                textFont(Courier14);
                                gestion.dessine_en_tete();
                                dec0.reordonne_onglets();
                                dec0.grand_onglet(zon0.nom_zone);
                                //-------------- insertion du véhicule ----------
                                dessine_rectangle(20F, 650F, 300F, 100F);
                                imageMode(CENTER);
                                image(vehicule.image_cote, 20F+300F/2F, 650F+100F/2F, vehicule.image_cote.width/4F, vehicule.image_cote.height/4F);
                                ecran      = createImage(width, height, RGB);                                                 //  ce sera l'image de l'écran, avec les rails
                                //------------ calcule l'image du fond d'ecran ---------------------
                                ecran.loadPixels();                                                                           //  prépare la variable écran
                                loadPixels();                                                                                 //  charge l'écran complet dans la variable Pixels()
                                for (int j = 0; j < pixels.length; j++) {
                                    ecran.pixels[j] = pixels[j];                                                              //  prépare la copie tous les pixels de l'écran dans la variable écran                                                                                               
                                }
                                ecran.updatePixels();                                                                         //  met à jours la variable écran. A noter que cette variable écran n'a pas de trains
                                break;
                            }
                        }
                        break;
                    }
                }
            }
        }
    }
    //------------------- dessine_en_tete() -----------------------------
    void dessine_en_tete() {
        affiche_en_tete = true;
        int fab = famille_choisie.indexOf("/");
        int mod = modele_choisi.indexOf("//");
        imageMode(CORNER);
        image(fond_alu, 0, 0, width,height);
        image(affiche_vert, 13F, 10F, (fabricant_choisi.length()+1F)*ZOOM, 15F);            
        image(affiche_vert, 23F+largeur_fabricant, 10F, (famille_choisie.substring(fab+1, famille_choisie.length()).length()+1)*ZOOM, 15F);
        image(affiche_vert, 52F+(fabricant_choisi.length()+1+famille_choisie.substring(fab+1, famille_choisie.length()).length()+1)*ZOOM, 10F, (modele_choisi.substring(mod+2, modele_choisi.length()).length()+2)*ZOOM, 15F);            
        fill(NOIR);
        textFont(Courier14);
        textAlign(LEFT, TOP);
        text(fabricant_choisi, 17F, 9F);
        text(famille_choisie.substring(fab+1, famille_choisie.length()), 27F+largeur_fabricant, 9F);
        text(modele_choisi.substring(mod+2, modele_choisi.length()), 56F+(fabricant_choisi.length()+1+famille_choisie.substring(fab+1, famille_choisie.length()).length()+1)*ZOOM, 9F);
        //----------------------- gros boutons bleus2 ---------------------------------
        groupe = groupes[2];
        groupe.dessine_gros_boutons(1000F, 5F, width-1000F-60F, 40F);
        groupe.appui_gros_boutons();
        if (ajouter_decodeur) {
            vehicule.fabricant = fabricant_choisi;
            vehicule.famille   = famille_choisie;
            vehicule.modele    = modele_choisi;
        }
    }
    //----------------------------- dessine_rectangle() -------------------------
    void dessine_rectangle(float _x0, float _y0, float _l0, float _h0) {
        float e = 1.3F;
        noStroke();
        fill(GRIS);
        rect(_x0, _y0, _l0, _h0);
        noFill();
        strokeWeight(2F*e);
        stroke(BLANC);
        rect(_x0, _y0, _l0, _h0);
        noStroke();
        fill(NOIR);
        quad(_x0-e, _y0-e,   _x0+_l0+e,  _y0-e,  _x0+_l0-e, _y0+e,  _x0+e, _y0+e);
        quad(_x0-e, _y0-e,   _x0-e,  _y0+_h0+e,  _x0+e, _y0+_h0-e,  _x0+e, _y0+e);
    }
    //----------------------------- dessine_rectangle_inverse() -------------------------
    void dessine_rectangle_inverse(float _x0, float _y0, float _l0, float _h0) {
        float e = 1.3F;
        //noStroke();
        //fill(GRIS);
        imageMode(CORNER);
        image(fond_alu1, _x0, _y0, _l0, _h0);
        noFill();
        strokeWeight(2F*e);
        stroke(NOIR);
        rect(_x0, _y0, _l0, _h0);
        noStroke();
        fill(BLANC);
        quad(_x0-e, _y0-e,   _x0+_l0+e,  _y0-e,  _x0+_l0-e, _y0+e,  _x0+e, _y0+e);
        quad(_x0-e, _y0-e,   _x0-e,  _y0+_h0+e,  _x0+e, _y0+_h0-e,  _x0+e, _y0+e);
    }
}
