//*********************************************************************************************************************
//----------------------------- creation_table_Materiel() ---------------------------------
void creation_table_Materiel() {
    Materiel = new Table();    
    Materiel.addColumn("nom");
    Materiel.addColumn("image");
    Materiel.addColumn("marque");
    Materiel.addColumn("ref");
    Materiel.addColumn("htamp");
    Materiel.addColumn("couleur");
    Materiel.addColumn("echelle");
    Materiel.addColumn("moteur");
    Materiel.addColumn("dcc");
    Materiel.addColumn("date");
    Materiel.addColumn("fabricant");
    Materiel.addColumn("famille");
    Materiel.addColumn("modele");
    Materiel.addColumn("longueur");
    Materiel.addColumn("largeur");
    Materiel.addColumn("hauteur");
    for (int i = 1; i < 201; i++) {
        Materiel.addColumn("CV"+str(i));
    }
    for (int i = 0; i < 5; i++) {
        Materiel.addColumn("P"+str(i));
    }
    Materiel.addColumn("ident");
}
//----------------------------- charge_table_Materiel() ------------------------------------
void charge_table_Materiel() {
    Materiel = loadTable(Repertoire_Communs+"Materiel/Materiel.tsv", "header, tsv");
    
    int compte_lignes = -1;
    toutes_marques.clear();
    for (TableRow row : Materiel.rows()) {
        compte_lignes++;
        String  _nom        = row.getString("nom");
        String  _image_t    = row.getString("image");
        String  _marque     = row.getString("marque");
        String  _ref        = row.getString("ref");
        int     _htamp      = row.getInt("htamp");
        color   _couleur    = unhex("FF"+row.getString("couleur").substring(1));                                                        //  unhex(String) -> int. String doit démarrer par FF. Il faut donc remplacer le 1er caractère (#)
        String  _echelle    = row.getString("echelle");
        boolean _moteur     = boolean(row.getInt("moteur"));
        boolean _dcc        = boolean(row.getInt("dcc"));
        String  _date       = row.getString("date");
        String  _fabricant  = row.getString("fabricant");
        String  _famille    = row.getString("famille");
        String  _modele     = row.getString("modele");
        int     _longueur   = row.getInt("longueur");
        int     _largeur    = row.getInt("largeur");
        int     _hauteur    = row.getInt("hauteur");
        int     _CV[]       = new int[201];
        for (int i = 1; i < 201; i++) {
            _CV[i]          = row.getInt("CV"+str(i));
        }
        int     _p[]        = new int[5];
        for (int i = 0; i < 5; i++) {
            _p[i]          = row.getInt("P"+str(i));
        }
        
        Vehicule veh1   = new Vehicule();
        veh1.nom        = _nom;
        veh1.image_t    = _image_t;
        veh1.image_cote = loadImage(Repertoire_Communs+"Materiel/"+_image_t);
        veh1.marque     = _marque;
        veh1.ref        = _ref;
        veh1.htamp      = _htamp;
        veh1.couleur    = _couleur;
        veh1.echelle    = _echelle;
        veh1.moteur     = _moteur;
        veh1.dcc        = _dcc;
        veh1.date       = _date;
        if (_fabricant.length() != 0 && !_fabricant.equals("Inconnu")) {
            veh1.fabricant  = _fabricant;
            veh1.famille    = _famille;
            veh1.modele     = _modele;
        } else {
            veh1.fabricant  = "Inconnu";
            veh1.famille    = "Inconnue";
            veh1.modele     = "Inconnu";
        }
        veh1.longueur      = _longueur;
        veh1.largeur       = _largeur;
        veh1.hauteur       = _hauteur;
        for (int i = 1; i < 201; i++) {
            veh1.CV[i] = _CV[i];
        }        
        for (int i = 0; i < 5; i++) {
            veh1.p[i] = _p[i];
        }        
        veh1.ID         = compte_lignes;
        veh1.filtre     = true;
        tous_vehicules_complet.add(veh1);
        tous_vehicules_filtres.add(veh1);
        tous_vehicules.add(veh1);
        //---------------------- liste des marques ----------------------
        boolean trouve = false;
        for (String marq0 : toutes_marques) {
            if (veh1.marque.equals(marq0)) {
                trouve = true;
                break;
            }
        }
        if (!trouve) {
            toutes_marques.append(veh1.marque);
        }
        toutes_marques.sort();
    }
}
//------------------------------ sauve_table_Materiel() ---------------------------------------------------------
void sauve_table_Materiel() {
    Materiel.clearRows();    
    TableRow newRow;    
    int compte_vehicules = -1;
    for (Vehicule veh0 : tous_vehicules_complet) {
        newRow = Materiel.addRow();
        compte_vehicules++;
        Materiel.setString(compte_vehicules, "nom",        veh0.nom);
        Materiel.setString(compte_vehicules, "image",      veh0.image_t);
        Materiel.setString(compte_vehicules, "marque",     veh0.marque);
        Materiel.setString(compte_vehicules, "ref",        veh0.ref);
        Materiel.setInt(   compte_vehicules, "htamp",      veh0.htamp);
        Materiel.setString(compte_vehicules, "couleur",    "#"+hex(color(veh0.couleur)).substring(2));                              //  hex(color) -> String. String doit démarrer par #. Il faut donc remplacer les deux 1er caractères (FF)
        Materiel.setString(compte_vehicules, "echelle",    veh0.echelle);
        Materiel.setInt(   compte_vehicules, "moteur",     int(veh0.moteur));
        Materiel.setInt(   compte_vehicules, "dcc",        int(veh0.dcc));
        Materiel.setString(compte_vehicules, "date",       veh0.date);
        Materiel.setString(compte_vehicules, "fabricant",  veh0.fabricant);
        Materiel.setString(compte_vehicules, "famille",    veh0.famille);
        Materiel.setString(compte_vehicules, "modele",     veh0.modele);
        Materiel.setInt(   compte_vehicules, "longueur",   veh0.longueur);
        Materiel.setInt(   compte_vehicules, "largeur",    veh0.largeur);
        Materiel.setInt(   compte_vehicules, "hauteur",    veh0.hauteur);
        for (int i = 1; i < 201; i++) {
            Materiel.setInt(compte_vehicules, "CV"+str(i), veh0.CV[i]);
        }
        for (int i = 0; i < 5; i++) {
            Materiel.setInt(compte_vehicules, "P"+str(i), veh0.p[i]);
        }
        Materiel.setInt(   compte_vehicules, "ident",      veh0.ID);
    }        
    saveTable(Materiel, Repertoire_Communs+"Materiel/Materiel.tsv");
}
//----------------------------- maj_date() ---------------------------------
void maj_date() {    
    String str_ye = str(year());
    String str_mo = str(100+month()).substring(1,3);
    String str_da = str(100+day()).substring(1,3);
    String str_ho = str(100+hour()).substring(1,3);
    String str_mi = str(100+minute()).substring(1,3);
    String str_se = str(100+second()).substring(1,3);
    date = str_ye+"_"+str_mo+"_"+str_da+"__"+str_ho+"_"+str_mi+"_"+str_se;
}
//----------------------------- creation_table_Materiel() ---------------------------------
void creation_table_Proprietaires() {
    Proprietaires = new Table();    
    Proprietaires.addColumn("CV106");
    Proprietaires.addColumn("prop");
    for (int i = 1; i < 29; i++) {
        Proprietaires.addColumn("F"+str(i));
    }
}
//----------------------------- charge_table_Proprietaires() ------------------------------------
void charge_table_Proprietaires() {  
    Proprietaires = loadTable(Repertoire_Communs+"Proprietaires/Proprietaires.tsv", "header, tsv");
    int compte_lignes = -1;
    tous_proprietaires.clear();
    for (TableRow row : Proprietaires.rows()) {
        compte_lignes++;
        int     _CV106  = row.getInt("CV106");
        String  _prop   = row.getString("prop");
        String  _F[]    = new String[29];
        for (int i = 1; i < 29; i++) {
            _F[i]       = row.getString("F"+str(i));
        }
        
        Proprietaire prop1 = new Proprietaire();
        prop1.CV106        = _CV106;
        prop1.prop         = _prop;
        for (int i = 1; i < 29; i++) {
            prop1.F[i] = _F[i];
        }        
        //---------------------- liste des proprietaires ----------------------
        Boolean trouve = false;
        for (Proprietaire prop0 : tous_proprietaires) {
            if (prop0.prop.equals(prop1)) {
                trouve = true;
                break;
            }
        }
        if (!trouve) {
            tous_proprietaires.add(prop1);
        }
    }
    tables_construites = true;
}
//*********************************************************************************************************************
//************************************ class Vehicule *********************************************************************************************************
class Vehicule {
    //------------------------------------- description -----------------
    String      nom;
    String      image_t;
    PImage      image_cote;
    String      marque;
    String      ref;
    int         htamp          = 0;                                                                                                                  //  longueur hors tampons mesurée sur le modèle
    color       couleur        = 0;        //  couleur du fond du véhicule
    String      echelle;
    boolean     moteur         = false;
    String      date;
    boolean     dcc;
    String      fabricant      = "Inconnu";
    String      famille        = "Inconnue";
    String      modele         = "Inconnu";
    int         longueur       = 0;
    int         largeur        = 0;
    int         hauteur        = 0;
    int         CV[]           = new int[201];
    int         p[]            = new int[5];
    int         sauve_CV[]     = new int[201];
    int         ID             = -1;
    boolean     filtre         = true;                                                                                                              //  par défaut, toutes les lignes sont affichées

    Vehicule() {}  //  constructeur
}
//*********************************************************************************************************************
//************************************ class Proprietaire *********************************************************************************************************
class Proprietaire {
    //------------------------------------- description -----------------
    int         CV106;
    String      prop;
    String      F[]            = new String[29];

    Proprietaire() {}  //  constructeur
}
